unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Quickrpt, qrprntr;

type
  TRunReport = function (ReportNumber: integer; PrintIt: boolean): word; stdcall;
  TDLLInitProc = procedure (fApplication: TApplication; fScreen: TScreen); stdcall;
  EDLLLoadError = class(Exception);

  TfrmMain = class(TForm)
    btnLoad: TButton;
    btnRun: TButton;
    btnFree: TButton;
    btnPrepare: TButton;
    btnLoadRunFree: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure btnLoadClick(Sender: TObject);
    procedure btnFreeClick(Sender: TObject);
    procedure btnRunClick(Sender: TObject);
    procedure btnPrepareClick(Sender: TObject);
    procedure btnLoadRunFreeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  LibHandle: THandle;
  RunReport: TRunReport;
  DLLInitProc: TDLLInitProc;

implementation

{$R *.DFM}

procedure TfrmMain.btnLoadClick(Sender: TObject);
begin
  LibHandle := LoadLibrary('QRDLL.DLL');
  btnRun.Enabled := False;
  btnPrepare.Enabled := False;
  btnFree.Enabled := False;
  btnLoadRunFree.Enabled := False;
  try
    if LibHandle = 0 then
      raise EDLLLoadError.Create('Unable to load DLL');
    @RunReport := GetProcAddress(LibHandle, 'RunReport');
    @DLLInitProc := GetProcAddress(LibHandle, 'DLLInitProc');
    btnLoad.Enabled := False;
    btnRun.Enabled := True;
    btnFree.Enabled := True;
    btnPrepare.Enabled := True;
  finally
  end;
end;

procedure TfrmMain.btnFreeClick(Sender: TObject);
begin
  try
    FreeLibrary(LibHandle);
    btnRun.Enabled := false;
    btnFree.Enabled := false;
    btnPrepare.Enabled := False;
    btnLoad.Enabled := true;
    btnLoadRunFree.Enabled := true;
  finally
  end;
end;

procedure TfrmMain.btnRunClick(Sender: TObject);
begin
  btnFree.Enabled := false;
  DLLInitProc(Application, Screen);
  RunReport(1, False);
  Application.ProcessMessages;
  btnFree.Enabled := true;
end;

procedure TfrmMain.btnPrepareClick(Sender: TObject);
begin
  btnFree.Enabled := false;
  btnPrepare.Enabled := False;
  DLLInitProc(Application, Screen);
  RunReport(2, False);
  btnPrepare.Enabled := true;
  btnFree.Enabled := true;
end;

procedure TfrmMain.btnLoadRunFreeClick(Sender: TObject);
var
  LibHandle: THandle;
  RunReport: TRunReport;
  DLLInitProc: TDLLInitProc;
begin
  LibHandle := LoadLibrary('QRDLL.DLL');
  btnLoadRunFree.Enabled := false;
  btnLoad.Enabled := false;
  try
    if LibHandle = 0 then
      raise EDLLLoadError.Create('Unable to load DLL');
    @RunReport := GetProcAddress(LibHandle, 'RunReport');
    @DLLInitProc := GetProcAddress(LibHandle, 'DLLInitProc');
    DLLInitProc(Application, Screen);
    RunReport(1, False);
  finally
    Application.ProcessMessages;
    FreeLibrary(LibHandle);
    btnLoadRunFree.Enabled := true;
    btnLoad.Enabled := true;
  end;
end;

end.
