library qrdll;
{$DEFINE TEST3DLL}

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  forms,
  qrdll1 in 'qrdll1.pas' {DlltestQR: TQuickRep},
  dllint in 'dllint.pas';

function RunReport(ReportNumber: integer; PrintIt: boolean): word; stdcall;
var
  DlltestQR : TDlltestQR;
begin
  result := 0;

  // We create a new instance of the report to allow multiple
  // entries into the DLL at the same time.
  DlltestQR := TDlltestQR.Create(nil);
  case ReportNumber of
    1:
    begin
      with DlltestQR do
      begin
        if PrintIt then
          Print
        else
          Preview;
      end;
    end;
    2: begin
      with DlltestQR do
      begin
        Prepare;
        qrprinter.free;
        qrprinter := nil;
      end;
    end;
  end;
  DlltestQR.free;
end;

// We pass in the current application and screen handles
// It is very important to reset them on the way out...
procedure DLLInitProc(fApplication: TApplication; fScreen: TScreen); stdcall;
begin
  Application := fApplication;
  Screen := fScreen;
end;

exports
  RunReport,
  DLLInitProc;
end.
